searchNodes=[{"doc":"protoc should always be used to generate code instead of writing the code by hand. By use this module, macros defined in Protobuf.DSL will be injected. Most of thee macros are equal to definition in .proto files. defmodule Foo do use Protobuf , syntax : :proto3 defstruct [ :a , :b ] field :a , 1 , type : :int32 field :b , 2 , type : :string end Your Protobuf message(module) is just a normal Elixir struct. Some useful functions are also injected, see &quot;Callbacks&quot; for details. Examples: foo1 = Foo . new! ( %{ a : 1 } ) foo1 . b == &quot;&quot; bin = Foo . encode ( foo1 ) foo1 == Foo . decode ( bin ) Except functions in &quot;Callbacks&quot;, some other functions may be defined: Extension functions when your Protobuf message use extensions. See Protobuf.Extension for details. put_extension(struct, extension_mod, field, value) get_extension(struct, extension_mod, field, default \\ nil)","ref":"Protobuf.html","title":"Protobuf","type":"behaviour"},{"doc":"Decodes a Protobuf binary into a struct. Errors may be raised if there's something wrong in the binary.","ref":"Protobuf.html#c:decode/1","title":"Protobuf.decode/1","type":"callback"},{"doc":"Decodes the given binary data interpreting it as the Protobuf message module . It's preferrable to use the message's decode/1 function. For a message MyMessage : MyMessage . decode ( &lt;&lt; ... &gt;&gt; ) #=&gt; %MyMessage{...} This function raises an error if anything goes wrong with decoding. Examples Protobuf . decode ( &lt;&lt; ... &gt;&gt; , MyMessage ) #=&gt; %MyMessage{...} Protobuf . decode ( &lt;&lt; &quot;bad data&quot; &gt;&gt; , MyMessage ) #=&gt; ** (Protobuf.DecodeError) ...","ref":"Protobuf.html#decode/2","title":"Protobuf.decode/2","type":"function"},{"doc":"Encodes the given Protobuf struct into a binary. If you want to encode to iodata instead, see encode_to_iodata/1 . Examples struct = MyMessage . new ( ) Protobuf . encode ( struct ) #=&gt; &lt;&lt;...&gt;&gt;","ref":"Protobuf.html#encode/1","title":"Protobuf.encode/1","type":"function"},{"doc":"Encodes the given struct into to a Protobuf binary. Errors may be raised if there's something wrong in the struct. If you want to encode to iodata instead of to a binary, use encode_to_iodata/1 .","ref":"Protobuf.html#c:encode/1","title":"Protobuf.encode/1","type":"callback"},{"doc":"Encodes the given Protobuf struct into iodata. Examples struct = MyMessage . new ( ) Protobuf . encode_to_iodata ( struct ) #=&gt; [...]","ref":"Protobuf.html#encode_to_iodata/1","title":"Protobuf.encode_to_iodata/1","type":"function"},{"doc":"Returns the unknown fields that were decoded but were not understood from the schema. In Protobuf, you can decode a payload (for the same message) encoded with a different version of the schema for that message. This can result in, for example, the payload containing fields that cannot be decoded correctly because they're not present in the schema used for decoding. These fields are skipped, but in some cases you might wish to preserve them in order to re-encode them, log them, or other. A common case is having to do &quot;round-trips&quot; with messages: you decode a payload, update the resulting message somehow, and re-encode it for future use. In these cases, you would probably want to re-encode the unknown fields to maintain symmetry. The returned value of this function is a list of {field_number, field_value} tuples where field_number is the number of the unknown field in the schema used for its encoding and field_value is its value. The library does not make any assumptions on the value of the field since it can't know for sure. This means that, for example, it can't properly decode an integer as signed or unsigned. The only guarantee is that the unknown fields are re-encoded correctly. The reason why these fields need to be accessed through this function is that the way they are stored in the struct is private. Examples Imagine you have this Protobuf schema: message User { string email = 1 ; } You encode this: payload = Protobuf . encode ( User . new! ( email : &quot; user @example . com ) ) #=&gt; &lt;&lt;...&gt;&gt; Now, you try to decode this payload using this schema instead: message User { string full_name = 2 ; } In this case, this function will return the decoded unknown field: message = User.decode(&lt;&lt;...&gt;&gt;) Protobuf.get_unknown_fields(message) #=&gt; [{_field_number = 1, _wire_type = 3, &quot;user@example.com}]","ref":"Protobuf.html#get_unknown_fields/1","title":"Protobuf.get_unknown_fields/1","type":"function"},{"doc":"Loads extensions modules. This function should be called in your application's Application.start/2 callback, as seen in the example below, if you wish to use extensions. Example @impl Application def start ( _type , _args ) do Protobuf . load_extensions ( ) Supervisor . start_link ( [ ] , strategy : :one_for_one ) end","ref":"Protobuf.html#load_extensions/0","title":"Protobuf.load_extensions/0","type":"function"},{"doc":"Builds a blank struct with default values. This and other &quot;new&quot; functions are preferred than raw building struct method like %Foo{} . In proto3, the zero values are the default values.","ref":"Protobuf.html#c:new/0","title":"Protobuf.new/0","type":"callback"},{"doc":"Builds and updates the struct with passed fields. This function will: Recursively call new/1 for embedded fields Create structs using struct/2 for keyword lists and maps Create the correct struct if passed the wrong struct Call new/1 for each element in the list for repeated fields Examples MyMessage . new ( field1 : &quot;foo&quot; ) #=&gt; %MyMessage{field1: &quot;foo&quot;, ...} MyMessage . new ( field1 : [ field2 : &quot;foo&quot; ] ) #=&gt; %MyMessage{field1: %MySubMessage{field2: &quot;foo&quot;}} MyMessage . new ( field1 : % WrongStruct { field2 : &quot;foo&quot; } ) #=&gt; %MyMessage{field1: %MySubMessage{field2: &quot;foo&quot;}} MyMessage . new ( repeated : [ %{ field1 : &quot;foo&quot; } , %{ field1 : &quot;bar&quot; } ] ) #=&gt; %MyMessage{repeated: [%MyRepeated{field1: &quot;foo&quot;}, %MyRepeated{field1: &quot;bar&quot;}]}","ref":"Protobuf.html#c:new/1","title":"Protobuf.new/1","type":"callback"},{"doc":"Similar to new/1 , but use struct!/2 to build the struct, so errors will be raised if unknown keys are passed.","ref":"Protobuf.html#c:new!/1","title":"Protobuf.new!/1","type":"callback"},{"doc":"Returns nil or a transformer module that implements the Protobuf.TransformModule behaviour. This function is overridable in your module.","ref":"Protobuf.html#c:transform_module/0","title":"Protobuf.transform_module/0","type":"callback"},{"doc":"","ref":"Protobuf.DSL.html","title":"Protobuf.DSL","type":"module"},{"doc":"Define &quot;extend&quot; for a message(the first argument module).","ref":"Protobuf.DSL.html#extend/4","title":"Protobuf.DSL.extend/4","type":"macro"},{"doc":"Define extensions range in the message module to allow extensions for this module.","ref":"Protobuf.DSL.html#extensions/1","title":"Protobuf.DSL.extensions/1","type":"macro"},{"doc":"Define a field in the message module.","ref":"Protobuf.DSL.html#field/3","title":"Protobuf.DSL.field/3","type":"macro"},{"doc":"Define oneof in the message module.","ref":"Protobuf.DSL.html#oneof/2","title":"Protobuf.DSL.oneof/2","type":"macro"},{"doc":"Extensions let you set extra fields for previously defined messages(even for messages in other packages) without changing the original message. To load extensions you should call Protobuf.load_extensions/0 when your application starts: def start ( _type , _args ) do Protobuf . load_extensions ( ) Supervisor . start_link ( [ ] , strategy : :one_for_one ) end Examples # protoc should be used to generate the code instead of writing by hand. defmodule Foo do use Protobuf , syntax : :proto2 extensions ( [ { 100 , 101 } , { 1000 , 536_870_912 } ] ) end # This module is generated for all &quot;extend&quot; calls in one file. # This module is needed in `*_extension` function because the field name is scoped # in the proto file. defmodule Ext.PbExtension do use Protobuf , syntax : :proto2 extend Foo , :my_custom , 1047 , optional : true , type : :string end foo = Foo . new ( ) Foo . put_extension ( foo , Ext.PbExtension , :my_custom , &quot;Custom field&quot; ) Foo . get_extension ( foo , Ext.PbExtension , :my_custom )","ref":"Protobuf.Extension.html","title":"Protobuf.Extension","type":"module"},{"doc":"The actual function for get_extension","ref":"Protobuf.Extension.html#get/4","title":"Protobuf.Extension.get/4","type":"function"},{"doc":"The actual function for put_extension","ref":"Protobuf.Extension.html#put/5","title":"Protobuf.Extension.put/5","type":"function"},{"doc":"JSON encoding and decoding utilities for Protobuf structs. It follows Google's specs and reference implementation. Some features such as well-known types are not fully supported yet. Proto3 is supported as per the specification. Proto2 is supported in practice, but some of its features might not work correctly, such as extensions. Types Protobuf JSON Supported bool true / false Yes int32 , fixed32 , uint32 Number Yes int64 , fixed64 , uint64 String Yes float , double Number Yes bytes Base64 string Yes string String Yes message Object ( {…} ) Yes enum String Yes map&lt;K,V&gt; Object ( {…} ) Yes repeated V Array of [v, …] Yes Any Object ( {…} ) No Timestamp RFC3339 datetime Yes Duration String ( seconds.fraction ) Yes Struct Object ( {…} ) Yes Wrapper types Various types Yes FieldMask String Yes ListValue Array Yes Value Any JSON value Yes NullValue null Yes Empty Object ( {…} ) Yes Usage Protobuf.JSON requires a JSON library to work, so first make sure you have :jason added to your dependencies: defp deps do [ { :jason , &quot;~&gt; 1.2&quot; } , # ... ] end With encode/1 you can turn any Protobuf message struct into a JSON string: iex&gt; message = Car . new ( color : :RED , top_speed : 125.3 ) iex&gt; Protobuf.JSON . encode ( message ) { :ok , &quot;{ \\&quot; color \\&quot; : \\&quot; RED \\&quot; , \\&quot; topSpeed \\&quot; :125.3}&quot; } And go the other way around with decode/1 : iex&gt; json = ~S|{&quot;color&quot;:&quot;RED&quot;,&quot;topSpeed&quot;:125.3}| iex&gt; Protobuf.JSON . decode ( json , Car ) { :ok , % Car { color : :RED , top_speed : 125.3 } } JSON keys are encoded as camelCase strings by default, specified by the json_name field option. So make sure to recompile the .proto files in your project before working with JSON encoding, the compiler will generate all the required json_name options. You can set your own json_name for a particular field too: message GeoCoordinate { double latitude = 1 [ json_name = &quot;lat&quot; ] ; double longitude = 2 [ json_name = &quot;long&quot; ] ; } Known Issues and Limitations Currently, the protoc compiler won't check for field name collisions. This library won't check that either. Make sure your field names will be unique when serialized to JSON. For instance, this message definition will not encode correctly since it will emit just one of the two fields and the problem might go unnoticed: message CollidingFields { int32 f1 = 1 [ json_name = &quot;sameName&quot; ] ; float f2 = 2 [ json_name = &quot;sameName&quot; ] ; } According to the specification, when duplicated JSON keys are found in maps, the library should raise a decoding error. It currently ignores duplicates and keeps the last occurrence.","ref":"Protobuf.JSON.html","title":"Protobuf.JSON","type":"module"},{"doc":"Decodes a JSON iodata into a module Protobuf struct. Examples Given this Protobuf message: syntax = &quot;proto3&quot; ; message Car { enum Color { GREEN = 0 ; RED = 1 ; } Color color = 1 ; float top_speed = 2 ; } You can build its structs from JSON like this: iex&gt; Protobuf.JSON . decode ( &quot;{}&quot; , Car ) { :ok , % Car { color : :GREEN , top_speed : 0.0 } } iex&gt; ~S|{&quot;color&quot;:&quot;RED&quot;}| |&gt; Protobuf.JSON . decode ( Car ) { :ok , % Car { color : :RED , top_speed : 0.0 } } iex&gt; ~S|{&quot;color&quot;:&quot;GREEN&quot;,&quot;topSpeed&quot;:80.0}| |&gt; Protobuf.JSON . decode ( Car ) { :ok , % Car { color : :GREEN , top_speed : 80.0 } }","ref":"Protobuf.JSON.html#decode/2","title":"Protobuf.JSON.decode/2","type":"function"},{"doc":"Decodes a JSON iodata into a module Protobuf struct. Similar to decode!/2 except it will unwrap the error tuple and raise in case of errors. Examples iex&gt; Protobuf.JSON . decode! ( &quot;{}&quot; , Car ) % Car { color : :GREEN , top_speed : 0.0 } iex&gt; ~S|{&quot;color&quot;:&quot;RED&quot;}| |&gt; Protobuf.JSON . decode! ( Car ) % Car { color : :RED , top_speed : 0.0 } iex&gt; ~S|{&quot;color&quot;:&quot;GREEN&quot;,&quot;topSpeed&quot;:80.0}| |&gt; Protobuf.JSON . decode! ( Car ) % Car { color : :GREEN , top_speed : 80.0 }","ref":"Protobuf.JSON.html#decode!/2","title":"Protobuf.JSON.decode!/2","type":"function"},{"doc":"Generates a JSON representation of the given protobuf struct . Options :use_proto_names - use original field name instead of the camelCase json_name for JSON keys. Defaults to false . :use_enum_numbers - encode enum field values as numbers instead of their labels. Defaults to false . :emit_unpopulated - emit all fields, even when they are blank, empty, or set to their default value. Defaults to false . Examples Suppose that this is you Protobuf message: syntax = &quot;proto3&quot; ; message Car { enum Color { GREEN = 0 ; RED = 1 ; } Color color = 1 ; float top_speed = 2 ; } Encoding is as simple as: iex&gt; Car . new ( color : :RED , top_speed : 125.3 ) |&gt; Protobuf.JSON . encode ( ) { :ok , ~S|{&quot;color&quot;:&quot;RED&quot;,&quot;topSpeed&quot;:125.3}| } iex&gt; Car . new ( color : :GREEN ) |&gt; Protobuf.JSON . encode ( ) { :ok , &quot;{}&quot; } iex&gt; Car . new ( ) |&gt; Protobuf.JSON . encode ( emit_unpopulated : true ) { :ok , ~S|{&quot;color&quot;:&quot;GREEN&quot;,&quot;topSpeed&quot;:0.0}| }","ref":"Protobuf.JSON.html#encode/2","title":"Protobuf.JSON.encode/2","type":"function"},{"doc":"Generates a JSON representation of the given protobuf struct . Similar to encode/2 except it will unwrap the error tuple and raise in case of errors. Examples iex&gt; Car . new ( top_speed : 80.0 ) |&gt; Protobuf.JSON . encode! ( ) ~S|{&quot;topSpeed&quot;:80.0}|","ref":"Protobuf.JSON.html#encode!/2","title":"Protobuf.JSON.encode!/2","type":"function"},{"doc":"Decodes a json_data map into a module Protobuf struct. Similar to decode/2 except it takes a JSON map representation of the data. This is especially useful if you want to use custom JSON encoding or a custom JSON library. Examples iex&gt; Protobuf.JSON . from_decoded ( %{ } , Car ) { :ok , % Car { color : :GREEN , top_speed : 0.0 } } iex&gt; Protobuf.JSON . from_decoded ( %{ &quot;color&quot; =&gt; &quot;RED&quot; } , Car ) { :ok , % Car { color : :RED , top_speed : 0.0 } } iex&gt; Protobuf.JSON . from_decoded ( %{ &quot;color&quot; =&gt; &quot;GREEN&quot; , &quot;topSpeed&quot; =&gt; 80.0 } , Car ) { :ok , % Car { color : :GREEN , top_speed : 80.0 } }","ref":"Protobuf.JSON.html#from_decoded/2","title":"Protobuf.JSON.from_decoded/2","type":"function"},{"doc":"Generates a JSON-encodable map for the given Protobuf struct . Similar to encode/2 except it will return an intermediate map representation. This is especially useful if you want to use custom JSON encoding or a custom JSON library. Supports the same options as encode/2 . Examples iex&gt; Car . new ( color : :RED , top_speed : 125.3 ) |&gt; Protobuf.JSON . to_encodable ( ) { :ok , %{ &quot;color&quot; =&gt; :RED , &quot;topSpeed&quot; =&gt; 125.3 } } iex&gt; Car . new ( color : :GREEN ) |&gt; Protobuf.JSON . to_encodable ( ) { :ok , %{ } } iex&gt; Car . new ( ) |&gt; Protobuf.JSON . to_encodable ( emit_unpopulated : true ) { :ok , %{ &quot;color&quot; =&gt; :GREEN , &quot;topSpeed&quot; =&gt; 0.0 } }","ref":"Protobuf.JSON.html#to_encodable/2","title":"Protobuf.JSON.to_encodable/2","type":"function"},{"doc":"","ref":"Protobuf.JSON.html#t:encode_opt/0","title":"Protobuf.JSON.encode_opt/0","type":"type"},{"doc":"","ref":"Protobuf.JSON.html#t:json_data/0","title":"Protobuf.JSON.json_data/0","type":"type"},{"doc":"protoc plugin for generating Elixir code. protoc-gen-elixir (this name is important) must be in $PATH . You are not supposed to call it directly, but only through protoc . Examples $ protoc --elixir_out=./lib your.proto $ protoc --elixir_out=plugins=grpc:./lib/ *.proto $ protoc -I protos --elixir_out=./lib protos/namespace/*.proto Options: --version Print version of protobuf-elixir --help (-h) Print this help","ref":"Protobuf.Protoc.CLI.html","title":"Protobuf.Protoc.CLI","type":"module"},{"doc":"","ref":"Protobuf.Protoc.CLI.html#supported_features/0","title":"Protobuf.Protoc.CLI.supported_features/0","type":"function"},{"doc":"Behaviour for transformer modules. By defining a transform_module/0 function on your protobuf message module you can add custom encoding and decoding logic for your message. The Protobuf.new/1 function will not be called for structs that have a transform module, if you still want to emulate this behavior you can use Protobuf.TransformModule.InferFieldsFromEnum . As an example we can use this to implement a message that will be decoded as a string value: defmodule StringMessage do use Protobuf , syntax : :proto3 defstruct [ :value ] field :value , 1 , type : :string def transform_module ( ) , do : MyTransformModule end The transformer behaviour implementation: defmodule MyTransformModule do @behaviour Protobuf.TransformModule @impl true def encode ( string , StringMessage ) when is_binary ( string ) , do : % StringMessage { value : string } @impl true def decode ( % StringMessage { value : string } , StringMessage ) , do : string end","ref":"Protobuf.TransformModule.html","title":"Protobuf.TransformModule","type":"behaviour"},{"doc":"Takes any protobuf message and the message type and encodes it into arbitrary Elixir term. Called after a message is decoded.","ref":"Protobuf.TransformModule.html#c:decode/2","title":"Protobuf.TransformModule.decode/2","type":"callback"},{"doc":"Takes any Elixir term and the protobuf message type and encodes it into that type. Called before a message is encoded.","ref":"Protobuf.TransformModule.html#c:encode/2","title":"Protobuf.TransformModule.encode/2","type":"callback"},{"doc":"","ref":"Protobuf.TransformModule.html#t:message/0","title":"Protobuf.TransformModule.message/0","type":"type"},{"doc":"","ref":"Protobuf.TransformModule.html#t:type/0","title":"Protobuf.TransformModule.type/0","type":"type"},{"doc":"","ref":"Protobuf.TransformModule.html#t:value/0","title":"Protobuf.TransformModule.value/0","type":"type"},{"doc":"For structs with a Protobuf.TransformModule set, the Protobuf.new/1 function does not get called. This transform module brings back the original behavior of calling Protobuf.new/1 before the value is encoded.","ref":"Protobuf.TransformModule.InferFieldsFromEnum.html","title":"Protobuf.TransformModule.InferFieldsFromEnum","type":"module"},{"doc":"Varint encoding and decoding utilities. https://developers.google.com/protocol-buffers/docs/encoding#varints For performance reasons, varint decoding must be built through a macro, so that binary match contexts are reused and no new large binaries get allocated. You can define your own varint decoders with the decoder macro, which generates function heads for up to 10-bytes long varint-encoded data. defmodule VarintDecoders do import Protobuf.Wire.Varint decoder :def , :decode_and_sum , [ :plus ] do { :ok , value + plus , rest } end def decode_all ( &lt;&lt; bin :: bits &gt;&gt; ) , do : decode_all ( bin , [ ] ) defp decode_all ( &lt;&lt; &gt;&gt; , acc ) , do : acc defdecoderp decode_all ( acc ) do decode_all ( rest , [ value | acc ] ) end end iex&gt; VarintDecoders . decode_and_sum ( &lt;&lt; 35 &gt;&gt; , 7 ) { :ok , 42 , &quot;&quot; } iex&gt; VarintDecoders . decode_all ( &quot;abcd asdf&quot; ) [ 102 , 100 , 115 , 97 , 32 , 100 , 99 , 98 , 97 ] Refer to efficiency guide for more on efficient binary handling. Encoding on the other hand is simpler. It takes an integer and returns an iolist with its varint representation: iex&gt; Protobuf.Wire.Varint . encode ( 35 ) [ 35 ] iex&gt; Protobuf.Wire.Varint . encode ( 1_234_567 ) [ &lt;&lt; 135 &gt;&gt; , &lt;&lt; 173 &gt;&gt; , 75 ]","ref":"Protobuf.Wire.Varint.html","title":"Protobuf.Wire.Varint","type":"module"},{"doc":"","ref":"Protobuf.Wire.Varint.html#defdecoderp/2","title":"Protobuf.Wire.Varint.defdecoderp/2","type":"macro"},{"doc":"","ref":"Protobuf.Wire.Varint.html#encode/1","title":"Protobuf.Wire.Varint.encode/1","type":"function"},{"doc":"","ref":"Protobuf.DecodeError.html","title":"Protobuf.DecodeError","type":"exception"},{"doc":"","ref":"Protobuf.EncodeError.html","title":"Protobuf.EncodeError","type":"exception"},{"doc":"","ref":"Protobuf.ExtensionNotFound.html","title":"Protobuf.ExtensionNotFound","type":"exception"},{"doc":"","ref":"Protobuf.InvalidError.html","title":"Protobuf.InvalidError","type":"exception"},{"doc":"","ref":"Protobuf.JSON.DecodeError.html","title":"Protobuf.JSON.DecodeError","type":"exception"},{"doc":"","ref":"Protobuf.JSON.DecodeError.html#new/1","title":"Protobuf.JSON.DecodeError.new/1","type":"function"},{"doc":"","ref":"Protobuf.JSON.DecodeError.html#t:t/0","title":"Protobuf.JSON.DecodeError.t/0","type":"type"},{"doc":"","ref":"Protobuf.JSON.EncodeError.html","title":"Protobuf.JSON.EncodeError","type":"exception"},{"doc":"","ref":"Protobuf.JSON.EncodeError.html#new/1","title":"Protobuf.JSON.EncodeError.new/1","type":"function"},{"doc":"","ref":"Protobuf.JSON.EncodeError.html#t:t/0","title":"Protobuf.JSON.EncodeError.t/0","type":"type"},{"doc":"","ref":"Protobuf.TypeEncodeError.html","title":"Protobuf.TypeEncodeError","type":"exception"},{"doc":"A pure Elixir implementation of Google Protobuf .","ref":"readme.html","title":"protobuf-elixir","type":"extras"},{"doc":"It has some must-have and other cool features like: A protoc plugin to generate Elixir code just like what other official libs do, which is powerful and reliable. Generate simple and explicit code with the power of Macro. See test/support/test_msg.ex . Plugins support. Only grpc is supported now. Use structs for messages instead of Erlang records. Support Typespec in generated code.","ref":"readme.html#why-this-instead-of-exprotobuf-gpb","title":"protobuf-elixir - Why this instead of exprotobuf(gpb)?","type":"extras"},{"doc":"The package can be installed by adding :protobuf to your list of dependencies in mix.exs : def deps do [ { :protobuf , &quot;~&gt; 0.10.0&quot; } , # Only for files generated from Google&#39;s protos. # Can be ignored if you don&#39;t use Google&#39;s protos. # Or you can generate the code by yourself. { :google_protos , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation","title":"protobuf-elixir - Installation","type":"extras"},{"doc":"Define messages with DSL Decode basic messages Skip unknown fields Decode embedded messages Decode packed and repeated fields Encode messages protoc plugin map Support default values Validate values Generate typespecs oneof (proto2) Extension (Experiment, see Protobuf.Extension )","ref":"readme.html#features","title":"protobuf-elixir - Features","type":"extras"},{"doc":"Generate Elixir code Download and install the protocol buffer compiler ( protoc ). MacOS users can also install it through Homebrew with brew install protobuf . Install protoc plugin protoc-gen-elixir for Elixir using the command below. Make sure the protoc-gen-elixir binary is in your PATH . Either add PATH=~/.mix/escripts:$PATH to your bash or zsh profile or, if you used asdf to install elixir, run asdf reshim and then verify that protoc-gen-elixir works: $ mix escript.install hex protobuf Generate Elixir code for helloworld.proto using protoc : $ protoc --elixir_out=./lib helloworld.proto A lib/helloworld.pb.ex file will be generated, like: defmodule Helloworld.HelloRequest do @moduledoc false use Protobuf , protoc_gen_elixir_version : &quot;0.10.0&quot; , syntax : :proto3 field :name , 1 , type : :string end defmodule Helloworld.HelloReply do @moduledoc false use Protobuf , protoc_gen_elixir_version : &quot;0.10.0&quot; , syntax : :proto3 field :message , 1 , type : :string end Encode and decode in your code struct = Foo . new ( a : 3.2 , c : Foo.Bar . new ( ) ) encoded = Foo . encode ( struct ) struct = Foo . decode ( encoded ) Note: Use YourModule.new(field: &quot;value&quot;) to ensure default values are set correctly for all fields instead of using the struct directly, as in %YourModule{field: &quot;value&quot;} . Validation is done during encoding. An error will be raised if the struct is invalid: when it misses a required field or has a mistyped value. Descriptor support If you use any custom options in your protobufs then to gain access to them you'll need to include the raw descriptors in the generated modules. You can generate the descriptors by passing gen_descriptors=true in --elixir_out . The descriptors will be available on each module from the descriptor/0 function. $ protoc --elixir_out=gen_descriptors=true:./lib/ *.proto $ protoc --elixir_out=gen_descriptors=true,plugins=grpc:./lib/ *.proto Package prefix You can use the package_prefix option to prefix generated Elixir code. For example to prefix generated Elixir modules with MyApp.Protos use my_app.protos as package prefix: $ protoc --elixir_out=./lib --elixir_opt=package_prefix=my_app.protos *.proto Transformer module By defining a callback transform_module/0 function on your protobuf message module you can add custom encoding and decoding logic for your message. See the documentation for Protobuf.TransformModule for more details. If your protobufs are generated from a .proto files you can add the callback function by passing transform_module=... in --elixir_out . $ protoc --elixir_out=transform_module=MyTransformModule:./lib/ *.proto One file per module You can use the one_file_per_module=true option to change the way that files are generated into directories. By default, one .pb.ex file is generated for each .proto file you compile and each of those .pb.ex files can have multiple Elixir module definitions in it. With one_file_per_module=true , one .pb.ex file will be generated for each generated Elixir module and the directory structure will respect Elixir conventions. For example, a MyPackage.MyMessage message will end up in the my_package/my_message.pb.ex file. $ protoc --elixir_out=one_file_per_module=true:./lib *.proto gRPC Support If you write services in protobuf, you can generate gRPC code by passing plugins=grpc in --elixir_out : $ protoc --elixir_out=plugins=grpc:./lib/ *.proto Tips for protoc Custom protoc-gen-elixir name or path using --plugin : $ protoc --elixir_out=./lib --plugin=./protoc-gen-elixir *.proto Pass -I argument if you import other protobuf files: $ protoc -I protos --elixir_out=./lib protos/hello.proto Custom options Since extensions( Protobuf.Extension ) is supported now, some options are defined, like custom module_prefix . Copy src/elixirpb.proto to your protos path. Import elixirpb.proto and use the options. syntax = &quot;proto2&quot;; package your.pkg; import &quot;elixirpb.proto&quot;; option (elixirpb.file).module_prefix = &quot;Foo.Bar&quot;; Generate code as before. More options will be added in the future, see elixirpb.proto comments for details.","ref":"readme.html#usage","title":"protobuf-elixir - Usage","type":"extras"},{"doc":"mix test","ref":"readme.html#tests","title":"protobuf-elixir - Tests","type":"extras"},{"doc":"Tubi Community","ref":"readme.html#sponsors","title":"protobuf-elixir - Sponsors","type":"extras"},{"doc":"Many thanks to gpb and golang/protobuf as good examples of writing Protobuf decoder/encoder.","ref":"readme.html#acknowledgements","title":"protobuf-elixir - Acknowledgements","type":"extras"}]